<instrumentationManifest
    xmlns="http://schemas.microsoft.com/win/2004/08/events"
    xmlns:trace="http://schemas.microsoft.com/win/2004/08/events/trace"
    xmlns:win="http://manifests.microsoft.com/win/2004/08/windows/events"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://schemas.microsoft.com/win/2004/08/events eventman.xsd">

    <instrumentation>
        <counters
            xmlns="http://schemas.microsoft.com/win/2005/12/counters"
            xmlns:auto-ns1="http://schemas.microsoft.com/win/2004/08/events"
            schemaVersion="1.1">

            <provider callback = "custom"
                      applicationIdentity = "%SystemRoot%\System32\drivers\ena.sys"
                      providerType = "kernelMode"
                      providerName = "ena"
                      providerGuid = "{2341db8f-5140-4726-9d0c-d69da733d1e9}">
                <counterSet guid        = "{28BF5299-96DD-41D9-9783-51D90700A765}"
                            uri         = "Aws.Ena.PacketsShaped"
                            name        = "ENA Packets Shaping"
                            description = "Packet numbers shaped due to various exceedings of traffic allowance"
                            symbol      = "PacketsShaped"
                            instances   = "multipleAggregate">

                <structs>
                    <struct name="PacketsShapedValues" type="PACKETS_SHAPED_VALUES"/>
                </structs>
                    <counter id           = "1"
                             uri          = "Aws.Ena.PacketsShaped.BwIn"
                             name         = "Aggregate inbound BW allowance exceeded"
                             struct       = "AllowanceExceededValues"
                             field        = "bw_in_allowance_exceeded"
                             description  = "The number of packets shaped due to inbound aggregate BW allowance being exceeded"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "2"
                             uri          = "Aws.Ena.PacketsShaped.BwOut"
                             name         = "Aggregate outbound BW allowance exceeded"
                             struct       = "AllowanceExceededValues"
                             field        = "bw_out_allowance_exceeded"
                             description  = "The number of packets shaped due to outbound aggregate BW allowance being exceeded"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "3"
                             uri          = "Aws.Ena.PacketsShaped.Pps"
                             name         = "PPS allowance exceeded"
                             struct       = "AllowanceExceededValues"
                             field        = "pps_allowance_exceeded"
                             description  = "The number of packets shaped due to PPS allowance being exceeded"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "4"
                             uri          = "Aws.Ena.PacketsShaped.ConnTrack"
                             name         = "Connection tracking allowance exceeded"
                             struct       = "AllowanceExceededValues"
                             field        = "conntrack_allowance_exceeded"
                             description  = "The number of packets shaped due to connection tracking allowance being exceeded and leading to failure in establishment of new connections"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "5"
                             uri          = "Aws.Ena.PacketsShaped.LinkLocal"
                             name         = "Link local packet rate allowance exceeded"
                             struct       = "AllowanceExceededValues"
                             field        = "linklocal_allowance_exceeded"
                             description  = "The number of packets shaped due to link local packet rate allowance being exceeded"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "6"
                             uri          = "Aws.Ena.PacketsShaped.ConnTrackAvailable"
                             name         = "Available Connection tracking allowance"
                             struct       = "AllowanceExceededValues"
                             field        = "conntrack_allowance_available"
                             description  = "The number of available instance connections tracked entries available for future connections"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "7"
                             uri          = "Aws.Ena.PacketsShaped.ena_srd_mode"
                             name         = "ena srd mode"
                             struct       = "AllowanceExceededValues"
                             field        = "ena_srd_mode"
                             description  = "Describes which ENA Express features are enabled"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "8"
                             uri          = "Aws.Ena.PacketsShaped.ena_srd_tx_pkts"
                             name         = "ena srd tx pkts"
                             struct       = "AllowanceExceededValues"
                             field        = "ena_srd_tx_pkts"
                             description  = "The number of SRD packets transmitted within a given time period"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "9"
                             uri          = "Aws.Ena.PacketsShaped.ena_srd_eligible_tx_pkts"
                             name         = "ena srd eligible tx pkts"
                             struct       = "AllowanceExceededValues"
                             field        = "ena_srd_eligible_tx_pkts"
                             description  = "The number of network packets sent within a given time period that meet SRD requirements for eligibility"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "10"
                             uri          = "Aws.Ena.PacketsShaped.ena_srd_rx_pkts"
                             name         = "ena srd rx pkts"
                             struct       = "AllowanceExceededValues"
                             field        = "ena_srd_rx_pkts"
                             description  = "The number of SRD packets received within a given time period"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                    <counter id           = "11"
                             uri          = "Aws.Ena.PacketsShaped.ena_srd_resource_utilization"
                             name         = "ena srd resource utilization"
                             struct       = "AllowanceExceededValues"
                             field        = "ena_srd_resource_utilization"
                             description  = "The percentage of the maximum allowed memory utilization for concurrent SRD connections that the instance has consumed"
                             type         = "perf_counter_rawcount"
                             detailLevel  = "standard">
                    </counter>
                </counterSet>
            </provider>
        </counters>
    </instrumentation>
</instrumentationManifest>